SystemOrganization addCategory: #'Mason-Examples'!

MDProduct subclass: #MDFilesystemDistProduct
	instanceVariableNames: 'package version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDFilesystemDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:04'!
build: anArray
	^ (self version: anArray) build! !

!MDFilesystemDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:04'!
version: anArray
	^ self basicNew initializeWithVersion: anArray! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:14'!
archiveName
	^ String streamContents:
		[:out |
		out nextPutAll: 'Filesystem-'.
		(version first: 3)
			do: [:number | out print: number]
			separatedBy: [out nextPut: $.].
		out nextPutAll: '.sar']! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:04'!
initializeWithVersion: anArray 
	package := MDMc1LatestProduct new
		packageName: 'Filesystem';
		repository: self repository;
		yourself.
	version := anArray! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:43'!
installerContent
	| memberName |
	memberName := FSPath * package latestVersion last withExtension: 'st'.
	^ String streamContents: 
		[ :out | 
		out
			nextPutAll: 'self fileInMemberNamed: ';
			nextPut: $';
			print: memberName;
			nextPut: $';
			nextPut: $.;
			cr;
			nextPutAll: 'FSReleaseInfo currentVersion: ';
			print: version;
			nextPut: $.;
			cr; cr;
			nextPutAll: 'self openTextFile: ''README''.';
			cr]! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:37'!
readMeContents
	^ 'This is the first release of Filesystem, an alternate interface for dealing with files and directories. The interface offers: 
	- Convient path manipulation
	- Transparent access to the contents of zip files
	- Late-bound references to files and directories
	- Robust support for working with entire directory trees
	
More information about how to use the Filesystem API is available at the following URL:

http://www.wiresong.ca/filesystem/

'! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2009 09:05'!
repository
	^MCHttpRepository
		location: 'http://source.wiresong.ca/mc'
		user: ''
		password: ''	! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:41'!
specifyOn: targets 
	targets zip
		name: self archiveName;
		with: 
			[package specifyOn: targets.
			targets file
				name: 'README';
				content: self readMeContents.
			targets directory
				name: 'install';
				with: 
					[targets file
						name: 'preamble';
						content: self installerContent]]! !
